/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cmath>
#include "bioritmo.h"

//! Pi Greco
static const long double pi = 3.14159265358979323846;

bioritmo::bioritmo(const QDate &n, const QDate &b)
{
	Birthdate = n;
	Bioritmo = b;

	make_bioritmi();
} // bioritmo (QDate, QDate);

bool bioritmo::set_bio_date(int date[])
{
	if ( Bioritmo.setYMD(date[2], date[1], date[0]) )
	{
		made = false;
		return true;
	} else return false;
} // set_bio_date(int []);

bool bioritmo::set_bio_date(int dd, int mm, int yy)
{
	if ( Bioritmo.setYMD(yy, mm, dd) )
	{
		made = false;
		return true;
	} else return false;
} // set_bio_date

bool bioritmo::set_bir_date(int date[])
{
	if ( Birthdate.setYMD(date[2], date[1], date[0]) )
	{
		made = false;
		return true;
	} else return false;
} // set_bir_date

bool bioritmo::set_bir_date(int dd, int mm, int yy)
{
	if ( Birthdate.setYMD(yy, mm, dd) )
	{
		made = false;
		return true;
	} else return false;
} // set_bir_date

void bioritmo::make_bioritmi()
{
	if ( ! made )
	{
		long int delta = Birthdate.daysTo(Bioritmo);
		CFisico 	= (int)(( sin ( 2 * pi * ( ( delta / 23.0 ) - ( delta / 23 ) ) ) * 100 ) + 0.5);
		CEmotivo 	= (int)(( sin ( 2 * pi * ( ( delta / 28.0 ) - ( delta / 28 ) ) ) * 100 ) + 0.5);
		CIntellettuale 	= (int)(( sin ( 2 * pi * ( ( delta / 33.0 ) - ( delta / 33 ) ) ) * 100 ) + 0.5);
		made = true;
	}
} // make_bioritmi

